/* Copyright 2023 Cipulot
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include QMK_KEYBOARD_H

const uint16_t PROGMEM keymaps[][MATRIX_ROWS][MATRIX_COLS] = {
    // clang-format off
    [0] = LAYOUT_all(
        KC_ESC,   KC_1,     KC_2,     KC_3,     KC_4,   KC_5,    KC_6,   KC_7,     KC_8,     KC_9,     KC_0,     KC_MINS,   KC_EQL,   KC_BSLS,   KC_GRV,
        KC_TAB,   KC_Q,     KC_W,     KC_E,     KC_R,   KC_T,    KC_Y,   KC_U,     KC_I,     KC_O,     KC_P,     KC_LBRC,   KC_RBRC,  KC_DEL,
        KC_LCTL,  KC_A,     KC_S,     KC_D,     KC_F,   KC_G,    KC_H,   KC_J,     KC_K,     KC_L,     KC_SCLN,  KC_QUOT,   KC_NUHS,  KC_ENTER,
        KC_LSFT,  KC_BSLS,  KC_Z,     KC_X,     KC_C,   KC_V,    KC_B,   KC_N,     KC_M,     KC_COMM,  KC_DOT,   KC_SLSH,   KC_RSFT,  MO(1),
                  KC_LGUI,  KC_LALT,                             KC_SPC,                               KC_RALT,  KC_RGUI),

    [1] = LAYOUT_all(
        _______,  KC_F1,    KC_F2,    KC_F3,    KC_F4,    KC_F5,    KC_F6,    KC_F7,      KC_F8,    KC_F9,    KC_F10,   KC_F11,    KC_F12,   KC_INS,  KC_DEL,
        KC_CAPS,  _______,  _______,  _______,  _______,  _______,  _______,  _______,    KC_PSCR,  KC_SCRL,  KC_PAUSE,  KC_UP,    _______,  KC_BSPC,
        _______,  KC_VOLD,  KC_VOLU,  KC_MUTE,  _______,  _______,  S(KC_8),  KC_SLSH,    KC_HOME,  KC_PGUP,  KC_LEFT,  KC_RIGHT,  _______,  _______,
        _______,  _______,  _______,  _______,  _______,  _______,  _______,  S(KC_EQL),  KC_MINS,  KC_END,   KC_PGDN,  KC_DOWN,   _______,  _______,
                  _______,  _______,                                _______,                                  _______,  MO(2)),

    [2] = LAYOUT_all(
        RGB_TOG,  RGB_VAD,  RGB_VAI,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  QK_BOOT,
        _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,
        _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,
        _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,
                  _______,  _______,                                _______,                                _______,  _______),
    [3] = LAYOUT_all(
        _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,
        _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,
        _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,
        _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,  _______,
                  _______,  _______,                                _______,                                _______,  _______)
    // clang-format on
};
